package example.nonpolymorphism;

import java.awt.Graphics;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;
import java.awt.Dimension;

public class NonPolyBounce extends JFrame
{
	private static final long serialVersionUID = 1L;

	class NonPolyBouncePanel extends JPanel
	{
		private static final long serialVersionUID = 1L;
		private Object[] list;
		
		public NonPolyBouncePanel()
		{
			System.out.println("Starting");
			setPreferredSize(new Dimension(500, 500));
			list = ObjectBuilder.createObjects();
		}

		public void paintComponent(Graphics g)
		{
			super.paintComponent(g);
			
			for (int i = 0; i < list.length; i++)
			{
				if (list[i] instanceof Oval)
				{
					Oval oval = (Oval) list[i];
					oval.drawOval(g);
				}
				else if (list[i] instanceof Square)
				{
					Square square = (Square) list[i];
					square.drawSquare(g);
				}
				else if (list[i] instanceof Triangle)
				{
					Triangle triangle = (Triangle) list[i];
					triangle.drawTriangle(g);
				}
				else
				{
					Circle circle = (Circle) list[i];
					circle.drawCircle(g);
				}
			}
			try
			{
				Thread.sleep(10);
			}
			catch (Exception error)
			{
				// do nothing
			}
			repaint();
		}
	}

	public static void main(String[] args)
	{
		new NonPolyBounce();
	}

	public NonPolyBounce()
	{
		try 
		{
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} 
		catch (Exception ex) 
		{
			ex.printStackTrace();
			System.exit(4);
		}
		setTitle("NonPolyBounce");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		add(new NonPolyBouncePanel());
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
	}
}
