package example.nonpolymorphism;

public class ObjectBuilder
{
	private static final int OVAL = 0;
	private static final int SQUARE = 1;
	private static final int TRIANGLE = 2;
	private static final int CIRCLE = 3;

	public static Object[] createObjects()
	{
		System.out.println("Creating objects");

		// create a random number between 3 and 13
		int size = (int) (Math.random() * 10) + 3;

		// create the array of Objects
		Object[] list = new Object[size];

		for (int i = 0; i < list.length; i++)
		{
			// create a random random object and add it to the list
			int selection = (int) (Math.random() * 4);
			switch (selection)
			{
				case OVAL:
				{
					Oval oval = new Oval();
					list[i] = oval;
					break;
				}
				case SQUARE:
				{
					Square square = new Square();
					list[i] = square;
					break;
				}
				case TRIANGLE:
				{
					Triangle triangle = new Triangle();
					list[i] = triangle;
					break;
				}
				case CIRCLE:
				{
					Circle circle = new Circle();
					list[i] = circle;
					break;
				}
			}
		}
		return list;
	}
}