package example.polymorphism;

import java.awt.Graphics;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.UIManager;
import java.awt.Dimension;

public class PolyBounce extends JFrame
{
	private static final long serialVersionUID = 1L;

	class PolyBouncePanel extends JPanel
	{
		private static final long serialVersionUID = 1L;
		private Shape[] list;
		
		public PolyBouncePanel()
		{
			System.out.println("Starting");
			setPreferredSize(new Dimension(500, 500));
			list = ShapeBuilder.createShapes();
		}

		public void paintComponent(Graphics g)
		{
			super.paintComponent(g);
			
			for (int i = 0; i < list.length; i++)
			{
				list[i].draw(g);
			}
			try
			{
				Thread.sleep(10);
			}
			catch (Exception error)
			{
				// do nothing
			}
			repaint();
		}
	}

	public static void main(String[] args)
	{
		new PolyBounce();
	}

	public PolyBounce()
	{
		try 
		{
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} 
		catch (Exception ex) 
		{
			ex.printStackTrace();
			System.exit(4);
		}
		setTitle("PolyBounce");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		add(new PolyBouncePanel());
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
	}
}
